﻿local JDI = JDI_2D07EA85_B774_43bf_873C_67DFA1FFDCA1;

JDI.GUI = {};
JDI.GUI.MainFrame = CreateFrame("Frame", "JoustDoItPanel", UIParent);

local MainFrame = JDI.GUI.MainFrame;
MainFrame.name = "Joust Do It!";
InterfaceOptions_AddCategory(MainFrame);

function MainFrame:DoInit()
    local maxwidth, frameheight = 400, 13;
    JDI.GUI.Width = maxwidth;
        
    MainFrame:SetWidth(maxwidth);
    MainFrame:SetScript("OnEvent", MainFrame.EventHandler);
    
    MainFrame.iddTitle = MainFrame:CreateFontString("$parent_Title","ARTWORK","GameFontNormalLarge");
    MainFrame.iddTitle:SetText("Joust Do It! v" .. JDI.JDIVERSION);
    MainFrame.iddTitle:SetPoint("TOPLEFT",MainFrame,"TOPLEFT",13,-frameheight);
    MainFrame.iddTitle:SetWidth(maxwidth - 26);
    MainFrame.iddTitle:SetJustifyH("CENTER");
    
    frameheight = frameheight + MainFrame.iddTitle:GetHeight() + 5;
    
    MainFrame.iddOptEnable = CreateFrame("CheckButton", nil, MainFrame, "InterfaceOptionsSmallCheckButtonTemplate");
    MainFrame.iddOptEnable.iddLabel = MainFrame:CreateFontString("$parent_CheckLabelEnable","ARTWORK","GameFontNormal");

    MainFrame.iddOptEnable:SetPoint("TOPLEFT", MainFrame, "TOPLEFT", 13, -frameheight);
    MainFrame.iddOptEnable:SetScript("OnClick", function(self, button)
            if (button == "LeftButton") then
                JDI:SetEnable();
                MainFrame:DoUpdate();
            end
        end);

    MainFrame.iddOptEnable.iddLabel:SetPoint("TOPLEFT", MainFrame.iddOptEnable, "TOPRIGHT");
    MainFrame.iddOptEnable.iddLabel:SetWidth(maxwidth - 26 - MainFrame.iddOptEnable:GetWidth());
    MainFrame.iddOptEnable.iddLabel:SetText(ENABLE);
    MainFrame.iddOptEnable.iddLabel:SetJustifyH("LEFT");
    MainFrame.iddOptEnable.iddLabel:SetJustifyV("MIDDLE");
    if (MainFrame.iddOptEnable.iddLabel:GetHeight() < MainFrame.iddOptEnable:GetHeight()) then
        MainFrame.iddOptEnable.iddLabel:SetHeight(MainFrame.iddOptEnable:GetHeight());
    end

    frameheight = frameheight + MainFrame.iddOptEnable.iddLabel:GetHeight() + 5;

    MainFrame.iddOptTarget = CreateFrame("CheckButton", nil, MainFrame, "InterfaceOptionsSmallCheckButtonTemplate");
    MainFrame.iddOptTarget.iddLabel = MainFrame:CreateFontString("$parent_CheckLabelTarget","ARTWORK","GameFontNormal");
    
    MainFrame.iddOptTarget:SetPoint("TOPLEFT", MainFrame, "TOPLEFT", 13, -frameheight);
    MainFrame.iddOptTarget:SetScript("OnClick", function(self, button)
            if (button == "LeftButton") then
                JDI:SetOptTarget();
                MainFrame:DoUpdate();
            end
        end);
            
    MainFrame.iddOptTarget.iddLabel:SetPoint("TOPLEFT", MainFrame.iddOptTarget, "TOPRIGHT");
    MainFrame.iddOptTarget.iddLabel:SetWidth(maxwidth - 26 - MainFrame.iddOptTarget:GetWidth());
    MainFrame.iddOptTarget.iddLabel:SetText(JDI.Locale.OptTarget);
    MainFrame.iddOptTarget.iddLabel:SetJustifyH("LEFT");
    MainFrame.iddOptTarget.iddLabel:SetJustifyV("MIDDLE");
    if (MainFrame.iddOptTarget.iddLabel:GetHeight() < MainFrame.iddOptTarget:GetHeight()) then
        MainFrame.iddOptTarget.iddLabel:SetHeight(MainFrame.iddOptTarget:GetHeight());
    end
    
    frameheight = frameheight + MainFrame.iddOptTarget.iddLabel:GetHeight() + 5;
    
    MainFrame.iddOptDismount = CreateFrame("CheckButton", nil, MainFrame, "InterfaceOptionsSmallCheckButtonTemplate");
    MainFrame.iddOptDismount.iddLabel = MainFrame:CreateFontString("$parent_CheckLabelDismount","ARTWORK","GameFontNormal");
    
    MainFrame.iddOptDismount:SetPoint("TOPRIGHT", MainFrame.iddOptTarget.iddLabel, "BOTTOMLEFT");
    MainFrame.iddOptDismount:SetScript("OnClick", function(self, button)
            if (button == "LeftButton") then
                JDI:SetOptDismount();
                MainFrame:DoUpdate();
            end
        end);
            
    MainFrame.iddOptDismount.iddLabel:SetPoint("TOPLEFT", MainFrame.iddOptDismount, "TOPRIGHT");
    MainFrame.iddOptDismount.iddLabel:SetWidth(maxwidth - 26 - MainFrame.iddOptDismount:GetWidth());
    MainFrame.iddOptDismount.iddLabel:SetText(JDI.Locale.OptDismount);
    MainFrame.iddOptDismount.iddLabel:SetJustifyH("LEFT");
    MainFrame.iddOptDismount.iddLabel:SetJustifyV("MIDDLE");
    if (MainFrame.iddOptDismount.iddLabel:GetHeight() < MainFrame.iddOptDismount:GetHeight()) then
        MainFrame.iddOptDismount.iddLabel:SetHeight(MainFrame.iddOptDismount:GetHeight());
    end
    
    frameheight = frameheight + MainFrame.iddOptTarget.iddLabel:GetHeight() + 5;
    
    MainFrame:SetHeight(frameheight + 8);
end

function MainFrame:Toggle()
    if InterfaceOptionsFrame:IsVisible() then
        InterfaceOptionsFrame:Hide();
    else
        InterfaceOptionsFrame_OpenToCategory(MainFrame);
    end
end

function MainFrame:DoUpdate()
    MainFrame.iddOptEnable:SetChecked(JDI.Vars.Enable);
    MainFrame.iddOptTarget:SetChecked(JDI.Vars.Target);
    MainFrame.iddOptDismount:SetChecked(JDI.Vars.Dismount);
end

function MainFrame:refresh()
    -- This function could probably replace DoUpdate in the future, but keep it separate for now
    MainFrame:DoUpdate();
end

function MainFrame:EventHandler(event, ...)
    if (JDI[event]) then
        JDI[event](self, ...);
    end
end
